# Generated by Django 3.2 on 2021-05-19 06:43

from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='AuthGroup',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=150, unique=True)),
            ],
            options={
                'db_table': 'auth_group',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='AuthGroupPermissions',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
            ],
            options={
                'db_table': 'auth_group_permissions',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='AuthPermission',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('codename', models.CharField(max_length=100)),
            ],
            options={
                'db_table': 'auth_permission',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='AuthUser',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128)),
                ('last_login', models.DateTimeField(blank=True, null=True)),
                ('is_superuser', models.IntegerField()),
                ('username', models.CharField(max_length=150, unique=True)),
                ('first_name', models.CharField(max_length=150)),
                ('last_name', models.CharField(max_length=150)),
                ('email', models.CharField(max_length=254)),
                ('is_staff', models.IntegerField()),
                ('is_active', models.IntegerField()),
                ('date_joined', models.DateTimeField()),
            ],
            options={
                'db_table': 'auth_user',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='AuthUserGroups',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
            ],
            options={
                'db_table': 'auth_user_groups',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='AuthUserUserPermissions',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
            ],
            options={
                'db_table': 'auth_user_user_permissions',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Cpumetrics',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('cpuuniqueid', models.CharField(max_length=255, unique=True)),
                ('customer_id', models.CharField(max_length=255)),
                ('system_id', models.CharField(max_length=255)),
                ('user', models.FloatField()),
                ('sys', models.FloatField()),
                ('iowait', models.FloatField()),
                ('steal', models.FloatField()),
                ('idle', models.FloatField()),
                ('created_at', models.CharField(max_length=255)),
                ('nice', models.CharField(blank=True, max_length=255, null=True)),
            ],
            options={
                'verbose_name_plural': 'CPU Metrics',
                'db_table': 'cpumetrics',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='CustomerMang',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('cusuniqueid', models.CharField(max_length=255, unique=True)),
                ('cuscomname', models.CharField(max_length=255)),
                ('cuscontactname', models.CharField(max_length=255)),
                ('cusmobnum', models.CharField(max_length=255)),
                ('cusaddress', models.TextField()),
                ('cusemail', models.CharField(max_length=255)),
                ('cuspassword', models.CharField(max_length=255)),
                ('isverified', models.IntegerField()),
                ('status', models.IntegerField()),
                ('created_at', models.CharField(max_length=255)),
                ('modified_at', models.CharField(max_length=255)),
                ('sub_by', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'customer_mang',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='DjangoAdminLog',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('action_time', models.DateTimeField()),
                ('object_id', models.TextField(blank=True, null=True)),
                ('object_repr', models.CharField(max_length=200)),
                ('action_flag', models.PositiveSmallIntegerField()),
                ('change_message', models.TextField()),
            ],
            options={
                'db_table': 'django_admin_log',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='DjangoContentType',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('app_label', models.CharField(max_length=100)),
                ('model', models.CharField(max_length=100)),
            ],
            options={
                'db_table': 'django_content_type',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='DjangoMigrations',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
                ('app', models.CharField(max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('applied', models.DateTimeField()),
            ],
            options={
                'db_table': 'django_migrations',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='DjangoSession',
            fields=[
                ('session_key', models.CharField(max_length=40, primary_key=True, serialize=False)),
                ('session_data', models.TextField()),
                ('expire_date', models.DateTimeField()),
            ],
            options={
                'db_table': 'django_session',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Fsmetircs',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('fsuniqueid', models.CharField(max_length=255, unique=True)),
                ('customer_id', models.CharField(max_length=255)),
                ('system_id', models.CharField(max_length=255)),
                ('filesys', models.CharField(max_length=255)),
                ('size', models.CharField(max_length=255)),
                ('used', models.CharField(max_length=255)),
                ('available', models.CharField(max_length=255)),
                ('perc', models.CharField(blank=True, max_length=255, null=True)),
                ('mounted_on', models.CharField(blank=True, db_column='Mounted_On', max_length=255, null=True)),
                ('created_at', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'fsmetircs',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Instancelist',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('insuniqueid', models.CharField(max_length=255, unique=True)),
                ('system_id', models.CharField(max_length=255)),
                ('customer_id', models.CharField(max_length=255)),
                ('sysname', models.CharField(max_length=255)),
                ('instanceno', models.IntegerField()),
                ('http_port', models.IntegerField()),
                ('https_port', models.IntegerField()),
                ('start_priority', models.IntegerField()),
                ('instancewsdlurl', models.CharField(max_length=255)),
                ('features', models.CharField(max_length=255)),
                ('status', models.CharField(max_length=255)),
                ('created_at', models.CharField(max_length=255)),
                ('modified_at', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'instancelist',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Memorymetrics',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('memuniqueid', models.CharField(max_length=255, unique=True)),
                ('customer_id', models.CharField(max_length=255)),
                ('system_id', models.CharField(max_length=255)),
                ('memtype', models.CharField(max_length=255)),
                ('total', models.CharField(max_length=255)),
                ('used', models.CharField(max_length=255)),
                ('free', models.CharField(max_length=255)),
                ('shared', models.CharField(max_length=255)),
                ('cache', models.CharField(max_length=255)),
                ('available', models.CharField(max_length=255)),
                ('port', models.IntegerField(blank=True, null=True)),
                ('created_at', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'memorymetrics',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='ProcessList',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('processuniqueid', models.CharField(max_length=255, unique=True)),
                ('customer_id', models.CharField(max_length=255)),
                ('system_id', models.CharField(max_length=255)),
                ('pname', models.CharField(max_length=255)),
                ('pdesc', models.CharField(max_length=255)),
                ('dispstatus', models.CharField(max_length=255)),
                ('stime', models.CharField(max_length=255)),
                ('created_at', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'process_list',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Systems',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('sysuniqueid', models.CharField(max_length=255, unique=True)),
                ('customer_id', models.CharField(max_length=255)),
                ('sysname', models.CharField(max_length=255)),
                ('sid', models.CharField(max_length=255)),
                ('ostype', models.CharField(max_length=255)),
                ('ipaddress', models.CharField(max_length=255)),
                ('portnum', models.IntegerField()),
                ('syspassword', models.CharField(max_length=255)),
                ('sitename', models.CharField(max_length=255)),
                ('sitetype', models.CharField(max_length=255)),
                ('siteincharge', models.CharField(max_length=255)),
                ('siteaddress', models.TextField()),
                ('status', models.IntegerField()),
                ('created_at', models.CharField(max_length=255)),
                ('modified_at', models.CharField(max_length=255)),
                ('sub_by', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'systems',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Systemwsdl',
            fields=[
                ('id', models.AutoField(db_column='Id', primary_key=True, serialize=False)),
                ('sywsdluniqueid', models.CharField(max_length=255, unique=True)),
                ('customer_id', models.CharField(max_length=255)),
                ('system_id', models.CharField(max_length=255)),
                ('syswsdlurl', models.CharField(max_length=255)),
                ('created_at', models.CharField(max_length=255)),
                ('modified_at', models.CharField(max_length=255)),
                ('sub_by', models.CharField(max_length=255)),
            ],
            options={
                'db_table': 'systemwsdl',
                'managed': False,
            },
        ),
    ]
