from django.shortcuts import render
from django.http import HttpResponse, HttpResponseNotFound
from rest_framework.parsers import JSONParser 
import datetime
import bcrypt
# Create your views here.
from rest_framework import viewsets
from rest_framework import status
from rest_framework.decorators import api_view
from rest_framework.response import Response
from .serializers import *
from .models import *
from cryptography.fernet import Fernet
import uuid
from requests import Session
from requests.auth import HTTPBasicAuth  # or HTTPDigestAuth, or OAuth1, etc.
from zeep.transports import Transport
from zeep import Client
from pyrfc import Connection
import ibm_db
import json
import time
import mysql.connector

from jinja2 import Environment, FileSystemLoader
from mail import *
from healthcheck_report import *
from os_healthcheck_report import *
from application_healthcheck_report import *
from db_healthcheck_report import *
import shutil
import os
mydb = mysql.connector.connect(
  host = "localhost",
  user = "Canopus",
  password = "care"
  
)

mycursor = mydb.cursor()


mycursor.execute("use care_new")
key = b'pRmgMa8T0INjEAfksaq2aafzoZXEuwKI7wDe4c1F8AY='
cipher_suite = Fernet(key)
# pwd = cipher_suite.encrypt(str.encode("Root@123"))
# epwd = pwd.decode()
# print(epwd)
# k = cipher_suite.decrypt(epwd.encode())
# print(k.decode())

def list_currentalerts(l):
		list_tree = []
		for i1 in l:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
			# print(i1)
			a = client.service.GetAlertTree()
			for i in a:
				if i['parent'] ==-1:
					i['parent'] = ""
				
				if i['name'] == None:
					i['name'] = "None"

				if i['parent'] == None:
					i['parent'] = "None"

				if i['ActualValue'] == None:
					i['ActualValue'] = "None"

				if i['description'] == None:
					i['description'] = "None"

				if i['Time'] == None:
					i['Time'] = "None"

				if i['AnalyseTool'] == None:
					i['AnalyseTool'] = "None"

				if i['VisibleLevel'] == None:
					i['VisibleLevel'] = "None"

				if i['HighAlertValue'] == None:
					i['HighAlertValue'] = "None"

				if i['AlDescription'] == None:
					i['AlDescription'] = "None"

				if i['AlTime'] == None:
					i['AlTime'] = "None"

				if i['Tid'] == None:
					i['Tid'] = "None"

			new_a = []
			dictionary = {}
			for i in a:
				dictionary = {}
				dictionary['name'] = i['name']
				dictionary['parent'] = i['parent']
				dictionary['ActualValue'] = i['ActualValue']
				dictionary['description'] = i['description']
				# dictionary['Time'] = i['Time']
				# dictionary['AnalyseTool'] = i['AnalyseTool']
				# dictionary['VisibleLevel'] = i['VisibleLevel']
				# dictionary['HighAlertValue'] = i['HighAlertValue']
				# dictionary['AlDescription'] = i['AlDescription']
				# dictionary['AlTime'] = i['AlTime']
				# dictionary['Tid'] = i['Tid']
				new_a.append(dictionary)


			tree = []
			list_ind = []
			for i in new_a:
			    ind = new_a.index(i)
			    i['Id'] = ind
			    list_ind.append(i)

			mappedarr = {}
			for i in list_ind:
			    Id  = i['Id']
			    if Id not in mappedarr.keys():
			        mappedarr[Id] = i
			        mappedarr[Id]['children'] = []

			    
			for i in mappedarr.keys():
			    mappedelement = mappedarr[i]

			    if mappedelement['parent']:
			        parentid = mappedelement['parent']
			        (mappedarr[parentid]['children']).append(mappedelement)

			    else:
			        tree.append(mappedelement) 
			list_tree.append(tree)
		return list_tree	        

def Connection(wsdl,adm,pwd):
	session = Session()
	session.auth = HTTPBasicAuth(adm,pwd)
	session.verify = True
	transport = Transport(session=session)
	client = Client(wsdl=wsdl, transport=transport)

	return client

def ConnectionValidate(wsdl,adm,pwd):
        session = Session()
        session.auth = HTTPBasicAuth(adm,pwd)
        session.verify = True
        transport = Transport(session=session,timeout=10)
        client = Client(wsdl=wsdl, transport=transport)

        return client

def WSDL(systemID):
	command="SELECT system_id,customer_id,syswsdlurl from systemwsdl where status = 1 and system_id='"+systemID+"' ;"
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	wsdl =[]
	wsdlarray = dict()
	for i in  myresult:
		index = myresult.index(i)
		
		command1 = "SELECT appuid,apppassword,ip,sid,dbtype from systems_v2 where sysuniqueid='"+i[0]+"';" 
		mycursor.execute(command1)
		myresult1 = mycursor.fetchall()
		pwd = cipher_suite.decrypt(str.encode(myresult1[0][1]))
		fpwd = pwd.decode()
		wsdlarray = {
		"wsdl" : i[2],
		"sid" : myresult1[0][0],
		"pwd" : fpwd,
		"ip" : myresult1[0][2],
		"system_id" : i[0],
		"customer_id" : i[1],
		"SID": myresult1[0][3],
		"dbtype": myresult1[0][4]

		}
		wsdl.append(wsdlarray)
	return wsdl	

def instWSDL(systemID):
	command="SELECT system_id,customer_id,instancewsdlurl,insuniqueid,features from instancelist where status = 1 and system_id='"+systemID+"' ;"
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	instwsdl =[]
	wsdlarray = dict()
	for i in  myresult:
		index = myresult.index(i)
		
		command1 = "SELECT appuid,apppassword,ip from systems_v2 where sysuniqueid='"+i[0]+"';" 
		mycursor.execute(command1)
		myresult1 = mycursor.fetchall()
		pwd = cipher_suite.decrypt(str.encode(myresult1[0][1]))

		fpwd = pwd.decode()
		wsdlarray = {
		"wsdl" : i[2],
		"sid" : myresult1[0][0],
		"pwd" : fpwd,
		"ip" : myresult1[0][2],
		"system_id" : i[0],
		"customer_id" : i[1],
		"instance_id" : i[3],
		"features":i[4]

		}
		instwsdl.append(wsdlarray)
	return instwsdl


def instWSDLsingle(systemID,instanceID):
	command="SELECT system_id,customer_id,instancewsdlurl,insuniqueid from instancelist where status = 1 and insuniqueid='"+instanceID+"' ;"
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	instwsdl =[]
	wsdlarray = dict()
	for i in  myresult:
		index = myresult.index(i)
		
		command1 = "SELECT appuid,apppassword,ip from systems_v2 where sysuniqueid='"+systemID+"';" 
		mycursor.execute(command1)
		myresult1 = mycursor.fetchall()
		pwd = cipher_suite.decrypt(str.encode(myresult1[0][1]))

		fpwd = pwd.decode()
		wsdlarray = {
		"wsdl" : i[2],
		"sid" : myresult1[0][0],
		"pwd" : fpwd,
		"ip" : myresult1[0][2],
		"system_id" : i[0],
		"customer_id" : i[1],
		"instance_id" : i[3]

		}
		instwsdl.append(wsdlarray)
	return instwsdl


def generatereport(healthcheck_id,log_id,system_id):
	healthcheck_id = healthcheck_id
	log_id = log_id	 
	system_id = system_id
	sid = SystemsV2.objects.filter(sysuniqueid = system_id).values('sid')[0]['sid']
	env = SystemsV2.objects.filter(sysuniqueid = system_id).values('systemtype')[0]['systemtype']		
	sysname = SystemsV2.objects.filter(sysuniqueid = system_id).values('sysname')[0]['sysname']
	dbtype = SystemsV2.objects.filter(sysuniqueid = system_id).values('dbtype')[0]['dbtype']
	log = Healthchecklogs.objects.filter(healthchecklogsuniqueid = log_id)	
	serializer = HealthchecklogsSerializer(log, many = True)
	run_by = serializer.data[0]['run_by']
	created_at = serializer.data[0]['created_at']
	created_at_modified = datetime.datetime.strptime(created_at,"%Y-%m-%d %H:%M:%S.%f")
	run_at = datetime.datetime(created_at_modified.year,created_at_modified.month,created_at_modified.day,created_at_modified.hour,created_at_modified.minute,created_at_modified.second)

	healthcheckdetails = {"sid":sid,
	"env":env,
	"dbtype":dbtype,
	"log_id":log_id,
	"run_by":run_by,
	"run_at":run_at}

	#runstatsdata = Runstats.objects.all()
	#runstats = RunstatsSerializer(runstatsdata, many = True)

	#sclientsdata = Systemclients.objects.all()
	#sclients = SystemclientsSerializer(sclientsdata, many = True)

	instdata = Instancelist.objects.filter(system_id = system_id)
	inst = InstSerializer(instdata, many = True)

	workprocessdata = Workprocess.objects.filter(log_id=log_id)
	workprocess = WorkprocessSerializer(workprocessdata, many = True)

	# abaplogsdata = Abaplogs.objects.filter(log_id=log_id)
	# abaplogs = AbaplogsSerializer(abaplogsdata, many = True)

	# licencedata = Licence.objects.filter(log_id=log_id)
	# licence = LicenceSerializer(licencedata, many = True)	

	memorydata = Memorymetrics.objects.filter(log_id=log_id)
	memory = MemorymetricsSerializer(memorydata, many = True)

	fsdata = Fsmetircs.objects.filter(log_id=log_id)
	fs = FsmetircsSerializer(fsdata, many = True)

	cpudata = Cpumetrics.objects.filter(log_id=log_id)
	cpu = CPUSerializer(cpudata, many = True)

	bufferdata = Healthcheckbuffer.objects.filter(log_id=log_id)
	buffer = HealthcheckbufferSerializer(bufferdata, many = True)

	responsetimesdata = Healthcheckresponsetimes.objects.filter(log_id=log_id)
	responsetimes = HealthcheckresponsetimesSerializer(responsetimesdata, many = True)

	updatemonitoringdata = Healthcheckupdatemonitoring.objects.filter(log_id=log_id)
	updatemonitoring = HealthcheckupdatemonitoringSerializer(updatemonitoringdata, many = True)

	runtimedumpsdata = Healthcheckruntimedumps.objects.filter(log_id=log_id)
	runtimedumps = HealthchekruntimedumpsSerializer(runtimedumpsdata, many = True)

	if healthcheck_id == '9670762fee9f4d95b745559293b3f667':
		if dbtype == "HANA":
			hanadbalertsdata = Hanadbalerts.objects.all()
			hanadbalerts = HanadbalertsSerializer(hanadbalertsdata, many = True)

			hanajobsdata = Hanajobs.objects.all()
			hanajobs = HanajobsSerializer(hanajobsdata, many = True)						
		
			output = {
			'memory':memory.data,
			'fs':fs.data,
			'workprocess':workprocess.data,
			# 'abaplogs':abaplogs.data,
			# 'licence':licence.data,
			'cpu' : cpu.data,
			'instances':inst.data,
			'hanadbalerts':hanadbalerts.data,
			'hanajobs':hanajobs.data,
			'updatemonitoring':updatemonitoring.data,
			'responsetimes':responsetimes.data,
			'buffer':buffer.data,
			'runtimedumps':runtimedumps.data
			}
		elif dbtype == "DB2":

			activelogsdata = Activelogs.objects.all()
			activelogs = ActivelogsSerializer(activelogsdata, many = True)

			bufferpooldata = Bufferpool.objects.all()
			bufferpool = BufferpoolSerializer(bufferpooldata, many = True)

			dbidata = DbInstances.objects.all()
			dbinstances = DbInstancesSerializer(dbidata, many = True)

			dblockdata = Dblocksnap.objects.all()
			dblock = DblocksnapSerializer(dblockdata, many = True)	

			output = {
			'memory':memory.data,
			'fs':fs.data,
			'workprocess':workprocess.data,
			# 'abaplogs':abaplogs.data,
			# 'licence':licence.data,
			'cpu' : cpu.data,
			'instances':inst.data,
			'activelogs':activelogs.data,
			'bufferpool':bufferpool.data,
			'dbinstances':dbinstances.data,
			'dblock':dblock.data,
			'updatemonitoring':updatemonitoring.data,
			'responsetimes':responsetimes.data,
			'buffer':buffer.data,
			'runtimedumps':runtimedumps.data
			}							

	elif healthcheck_id == '9670762fee9f4d95b745559293b3f645':
		output = {
		'memory':memory.data,
		'fs':fs.data,
		'cpu' : cpu.data,
    		'instances':inst.data
		}

	elif healthcheck_id == '9670762fee9f4d95b745559293b3f623':
		output = {
		'workprocess':workprocess.data,
		# 'abaplogs':abaplogs.data,
		# 'licence':licence.data,
		'instances':inst.data,
		'updatemonitoring':updatemonitoring.data,
		'responsetimes':responsetimes.data,
		'buffer':buffer.data,
		'runtimedumps':runtimedumps.data
		}

	if healthcheck_id == '9670762fee9f4d95b745559293b3f612':
		if dbtype == "HANA":
			hanadbalertsdata = Hanadbalerts.objects.all()
			hanadbalerts = HanadbalertsSerializer(hanadbalertsdata, many = True)

			hanajobsdata = Hanajobs.objects.all()
			hanajobs = HanajobsSerializer(hanajobsdata, many = True)						
		
			output = {
			'hanadbalerts':hanadbalerts.data,
			'hanajobs':hanajobs.data,
			'instances':inst.data
			}
		elif dbtype == "DB2":

			activelogsdata = Activelogs.objects.all()
			activelogs = ActivelogsSerializer(activelogsdata, many = True)

			bufferpooldata = Bufferpool.objects.all()
			bufferpool = BufferpoolSerializer(bufferpooldata, many = True)

			dbidata = DbInstances.objects.all()
			dbinstances = DbInstancesSerializer(dbidata, many = True)

			dblockdata = Dblocksnap.objects.all()
			dblock = DblocksnapSerializer(dblockdata, many = True)	

			output = {
			'activelogs':activelogs.data,
			'bufferpool':bufferpool.data,
			'dbinstances':dbinstances.data,
			'dblock':dblock.data
			}

	filename = healthcheckdetails["sid"] + '_' + healthcheckdetails["env"] + '_' +'%s' % healthcheckdetails["run_at"] + '.pdf'	

	if healthcheck_id =='9670762fee9f4d95b745559293b3f667':				
		doc = all_name(healthcheckdetails)
		generatepdf(healthcheckdetails,output,doc)
		#src = os.path.join(os.getcwd(),filename)
		#dst = os.path.join(os.getcwd(),'static/',filename)
		attachment_path = os.path.join('/var/www/html/caremigration/static/',filename)
		#shutil.move(src, dst)
		log_obj = Healthchecklogs.objects.get(healthchecklogsuniqueid = log_id)
		log_obj.report_path = attachment_path
		log_obj.filename = filename
		log_obj.save()			

	elif healthcheck_id =='9670762fee9f4d95b745559293b3f645':	
		doc = os_name(healthcheckdetails)
		osgeneratepdf(healthcheckdetails,output,doc)
		attachment_path = os.path.join('/var/www/html/caremigration/static/',filename)
		log_obj = Healthchecklogs.objects.get(healthchecklogsuniqueid = log_id)
		log_obj.report_path = attachment_path
		log_obj.filename = filename
		log_obj.save()

	elif healthcheck_id =='9670762fee9f4d95b745559293b3f623':	
		doc = app_name(healthcheckdetails)
		appgeneratepdf(healthcheckdetails,output,doc)
		attachment_path = os.path.join('/var/www/html/caremigration/static/',filename)
		log_obj = Healthchecklogs.objects.get(healthchecklogsuniqueid = log_id)
		log_obj.report_path = attachment_path
		log_obj.filename = filename
		log_obj.save()

	elif healthcheck_id =='9670762fee9f4d95b745559293b3f612':	
		doc = db_name(healthcheckdetails)
		dbgeneratepdf(healthcheckdetails,output,doc)
		attachment_path = os.path.join('/var/www/html/caremigration/static/',filename)
		log_obj = Healthchecklogs.objects.get(healthchecklogsuniqueid = log_id)
		log_obj.report_path = attachment_path
		log_obj.filename = filename
		log_obj.save()
	#return filename



# def sysclient(system_id,customer_id,email):
# 	conn = Connection(user='sap*', passwd='care4canopus', ashost='192.168.0.181', sysnr='22', client='000')
# 	result = conn.call('RFC_READ_TABLE',QUERY_TABLE = "T000",DELIMITER=',')		
# 	sysid = system_id
# 	cusid = customer_id
# 	created_at = datetime.datetime.now()
# 	sub_by = email
# 	log_id = uuid.uuid4()
# 	healthchechid = '9670762fee9f4d95b745559293b3f671'
# 	for i in result['DATA']:
# 		uclientuniqueid = uuid.uuid4()
# 		clientno = i['WA'].split(",")[0]
# 		clientname = i['WA'].split(",")[1]
# 		location = i['WA'].split(",")[2]
# 		currency = i['WA'].split(",")[3]
# 		uc = Systemclients(clientuniqueid=uclientuniqueid.hex,customer_id= cusid,system_id=sysid,clientno = clientno,clientname= clientname,location=location,currency=currency,created_at=created_at,sub_by=sub_by,log_id=log_id)
# 		uc.save()
# 	status = 1
# 	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
# 	log.save()	



def db_instance_details(system_id,customer_id,email,wsdl,log_id,created_at):
	ip = wsdl[0]['ip']
	dbport = wsdl[0]['dbport']
	sid = wsdl[0]['SID']
	dbpwd = wsdl[0]['dbpwd'] 
	sid_lower = sid.lower()
	db = (
	    "DRIVER=IBM DB2 ODBC DRIVER;" 
	    "DATABASE="+sid+";"
	    "HOSTNAME="+ip+";"
	    "PORT="+dbport+";"
	    "PROTOCAL=TCPIP;"
	    "UID=db2"+sid_lower+";"
	    "PWD="+dbpwd+";")	
	conn = ibm_db.connect(db,"","")	
	stmt = ibm_db.exec_immediate(conn,"SELECT DISTINCT INSTNAME AS INST, HOST AS HOST, APSERVER AS APS, OPSYS AS OPS from SAP"+sid+".TPFID ORDER BY OPSYS")
	metrics = ['Instname','Host','APSERVER','OS']
	sub_by = email
	sysid = system_id
	cusid = customer_id
	while ibm_db.fetch_row(stmt)!= False:
		for i in range(4):

			dbuniqid = uuid.uuid4()
			value = ibm_db.result(stmt,i)
			metric = metrics[i]

			inst = DbInstances(dbiuniqueid=dbuniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)

			inst.save()
	    	
def runstats(system_id,customer_id,email,wsdl,log_id,created_at):
	ip = wsdl[0]['ip']
	dbport = wsdl[0]['dbport']
	sid = wsdl[0]['SID']
	dbpwd = wsdl[0]['dbpwd'] 
	sid_lower = sid.lower()
	db = (
	    "DRIVER=IBM DB2 ODBC DRIVER;" 
	    "DATABASE="+sid+";"
	    "HOSTNAME="+ip+";"
	    "PORT="+dbport+";"
	    "PROTOCAL=TCPIP;"
	    "UID=db2"+sid_lower+";"
	    "PWD="+dbpwd+";")	
	conn = ibm_db.connect(db,"","")
	stmt = ibm_db.exec_immediate(conn,"SELECT substr(tabschema,1,10) as Schema, count(*) as count  from syscat.tables where days(current date) - days(stats_time) > 15 and type='T' group by tabschema order by count")
	sub_by = email
	sysid = system_id
	cusid = customer_id
	while ibm_db.fetch_row(stmt)!= False:
		rsuniqueid = uuid.uuid4()
		metric = ibm_db.result(stmt,0)
		value = ibm_db.result(stmt,1)

		inst = Runstats(rsuniqueid=rsuniqueid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)

		inst.save()



def Lockwaits(system_id,customer_id,email,wsdl,log_id,created_at):
	ip = wsdl[0]['ip']
	dbport = wsdl[0]['dbport']
	sid = wsdl[0]['SID']
	dbpwd = wsdl[0]['dbpwd'] 
	sid_lower = sid.lower()
	db = (
	    "DRIVER=IBM DB2 ODBC DRIVER;" 
	    "DATABASE="+sid+";"
	    "HOSTNAME="+ip+";"
	    "PORT="+dbport+";"
	    "PROTOCAL=TCPIP;"
	    "UID=db2"+sid_lower+";"
	    "PWD="+dbpwd+";")	
	conn = ibm_db.connect(db,"","")	
	stmt = ibm_db.exec_immediate(conn,"SELECT (char(count(*))) FROM SYSIBMADM.SNAPLOCKwait")
	stmt1 = ibm_db.exec_immediate(conn,"SELECT (char(count(*))) FROM SYSIBMADM.SNAPLOCK")
	sub_by = email
	sysid = system_id
	cusid = customer_id
	while ibm_db.fetch_row(stmt)!= False:
		dbuniqid = uuid.uuid4()
		metric = 'Locks Wait'
		value = ibm_db.result(stmt,0)
		lock = Dblocksnap(dblockuniqueid=dbuniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		lock.save()

	while ibm_db.fetch_row(stmt1)!= False:
		dbuniqid1 = uuid.uuid4()
		metric = 'Locks Held'
		value = ibm_db.result(stmt1,0)
		lock = Dblocksnap(dblockuniqueid=dbuniqid1.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		lock.save()

def activelogs(system_id,customer_id,email,wsdl,log_id,created_at):
	ip = wsdl[0]['ip']
	dbport = wsdl[0]['dbport']
	sid = wsdl[0]['SID']
	dbpwd = wsdl[0]['dbpwd'] 
	sid_lower = sid.lower()
	db = (
	    "DRIVER=IBM DB2 ODBC DRIVER;" 
	    "DATABASE="+sid+";"
	    "HOSTNAME="+ip+";"
	    "PORT="+dbport+";"
	    "PROTOCAL=TCPIP;"
	    "UID=db2"+sid_lower+";"
	    "PWD="+dbpwd+";")	
	conn = ibm_db.connect(db,"","")
	stmt = ibm_db.exec_immediate(conn,"SELECT substr(VALUE,1,10) FROM SYSIBMADM.DBCFG WHERE NAME LIKE '%logprimary%'")
	stmt1 = ibm_db.exec_immediate(conn,"SELECT substr(VALUE,1,10) FROM SYSIBMADM.DBCFG WHERE NAME LIKE '%logsecond%'")
	stmt2 = ibm_db.exec_immediate(conn,"SELECT  ltrim(char(SEC_LOGS_ALLOCATED))  FROM SYSIBMADM.SNAPDB")
	stmt3 = ibm_db.exec_immediate(conn,"SELECT ltrim(rtrim(char(value)))  FROM SYSIBMADM.DBCFG where name='logfilsiz'")
	stmt4 = ibm_db.exec_immediate(conn,"SELECT  ltrim(char(total_log_available))  FROM SYSIBMADM.SNAPDB")
	stmt5 = ibm_db.exec_immediate(conn,"SELECT  ltrim(char(total_log_used))  FROM SYSIBMADM.SNAPDB")
	stmt6 = ibm_db.exec_immediate(conn,"SELECT ltrim(char(log_to_redo_for_recovery))  FROM SYSIBMADM.SNAPDB")
	sub_by = email
	sysid = system_id
	cusid = customer_id

	while ibm_db.fetch_row(stmt)!= False:
		al1uniqid = uuid.uuid4()
		metric = 'Log Primary'
		value = ibm_db.result(stmt,0)
		alog = Activelogs(alogsuniqueid=al1uniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()

	while ibm_db.fetch_row(stmt1)!= False:
		al1uniqid1 = uuid.uuid4()
		metric = 'Log secondary'
		value = ibm_db.result(stmt1,0)
		alog = Activelogs(alogsuniqueid=al1uniqid1.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()
	while ibm_db.fetch_row(stmt2)!= False:
		al1uniqid2 = uuid.uuid4()
		metric = 'Secondary Logs Allocated'
		value = ibm_db.result(stmt2,0)
		alog = Activelogs(alogsuniqueid=al1uniqid2.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()

	while ibm_db.fetch_row(stmt3)!= False:
		al1uniqid3 = uuid.uuid4()
		metric = 'Log File Size'
		value = ibm_db.result(stmt3,0)
		alog = Activelogs(alogsuniqueid=al1uniqid3.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()

	while ibm_db.fetch_row(stmt4)!= False:
		al1uniqid4 = uuid.uuid4()
		metric = 'LOG_SPACE_AVAILABLE'
		value = ibm_db.result(stmt4,0)
		alog = Activelogs(alogsuniqueid=al1uniqid4.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()

	while ibm_db.fetch_row(stmt5)!= False:
		al1uniqid5 = uuid.uuid4()
		metric = 'LOG_SPACE_USED'
		value = ibm_db.result(stmt5,0)
		alog = Activelogs(alogsuniqueid=al1uniqid5.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()

	while ibm_db.fetch_row(stmt6)!= False:
		al1uniqid6 = uuid.uuid4()
		metric = 'Log Recovery'
		value = ibm_db.result(stmt6,0)
		alog = Activelogs(alogsuniqueid=al1uniqid6.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
		alog.save()

def licence(system_id,customer_id,email,wsdl,log_id,created_at):
		for i1 in wsdl:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])	
			a = client.service.OSExecute(command = "/usr/sap/SOD/SYS/exe/uc/linuxx86_64/saplikey -show pf=/sapmnt/SOD/profile/DEFAULT.PFL",**{'async':0},timeout=30 )
			sysid = system_id
			cusid = customer_id
			created_at = datetime.datetime.now()
			sub_by = email
			# log_id = uuid.uuid4()
			# healthchechid = '9670762fee9f4d95b745559293b3f661'
			lkuniqueid1 = uuid.uuid4()
			lkuniqueid2 = uuid.uuid4()
			hardwarekey = (a['lines']['item'][17].split())[-1]
			softwareproduct = (a['lines']['item'][18].split())[-1]
			validityend = (a['lines']['item'][24].split())[-1]
			hardwarekey1 = (a['lines']['item'][31].split())[-1]
			softwareproduct1 = (a['lines']['item'][32].split())[-1]
			validityend1 = (a['lines']['item'][38].split())[-1]
			lk1 = Licence(licencesuniqueid=lkuniqueid1.hex,customer_id= cusid,system_id=sysid,hardwarekey = hardwarekey,softwareproduct= softwareproduct,validityend=validityend,created_at=created_at,sub_by=sub_by,log_id=log_id)

			lk2 = Licence(licencesuniqueid=lkuniqueid2.hex,customer_id= cusid,system_id=sysid,hardwarekey = hardwarekey1,softwareproduct= softwareproduct1,validityend=validityend1,created_at=created_at,sub_by=sub_by,log_id=log_id)

			lk1.save()
			lk2.save()

def abaplogs(system_id,customer_id,email,wsdl,log_id,created_at):
		for i1 in wsdl:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
			a = client.service.ABAPReadSyslog()
			sysid = system_id
			cusid = customer_id
			# created_at = datetime.datetime.now()
			sub_by = email
			# log_id = uuid.uuid4()
			# healthchechid = '9670762fee9f4d95b745559293b3f651'
			list_abaplogs = a[0:10]
			for i in list_abaplogs:
				aluniqueid = uuid.uuid4()
				Time = i['Time']
				Typ = i['Typ']
				Client = i['Client']
				User = i['User']
				Tcode = i['Tcode']
				MNo = i['MNo']
				Text = i['Text']
				Severity = i['Severity']
				al = Abaplogs(abaplogsuniqueid=aluniqueid.hex,customer_id= cusid,system_id=sysid,time = Time,typ= Typ,client=Client,user =User,tcode=Tcode,mno=MNo,text=Text,severity=Severity,created_at=created_at,sub_by=sub_by,log_id=log_id)
				al.save()


def hanadbalerts(system_id,customer_id,email,wsdl,log_id,created_at):
	for i1 in wsdl:
		client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
		a = client.service.OSExecute(command= "//usr/sap/S4H/hdbclient/hdbsql -U DEFAULT ""SELECT * from ""_SYS_STATISTICS"".""STATISTICS_ALERTS"" WHERE ALERT_TIMESTAMP >= add_days(CURRENT_DATE, -1) order by alert_timestamp desc""",**{'async':0},timeout=30 )
		sysid = system_id
		cusid = customer_id
		sub_by = email		
		del a['lines']['item'][0]
		del a['lines']['item'][-1]
		if len(a['lines']['item'])<10:
					for i in a['lines']['item']:
						alert = i.split(",")
						dbalertsuniqueid = uuid.uuid4()
						alertobj = Hanadbalerts(dbalertsuniqueid = dbalertsuniqueid.hex,customer_id = cusid,system_id = sysid,snapshot_id=alert[0],alert_id=alert[1],index=alert[2],alert_host=alert[3],alert_port=alert[4],alert_rating=alert[5],alert_timestamp=alert[6],alert_details=alert[7],created_at= created_at,sub_by=sub_by,log_id=log_id)
						alertobj.save()
		else:				
			for i in a['lines']['item'][0:11]:
				alert = i.split(",")
				dbalertsuniqueid = uuid.uuid4()
				alertobj = Hanadbalerts(dbalertsuniqueid = dbalertsuniqueid.hex,customer_id = cusid,system_id = sysid,snapshot_id=alert[0],alert_id=alert[1],index=alert[2],alert_host=alert[3],alert_port=alert[4],alert_rating=alert[5],alert_timestamp=alert[6],alert_details=alert[7],created_at= created_at,sub_by=sub_by,log_id=log_id)
				alertobj.save()

def hanajobs(system_id,customer_id,email,wsdl,log_id,created_at):
	for i1 in wsdl:
		client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
		sysid = system_id
		cusid = customer_id
		sub_by = email		
		a = client.service.OSExecute(command= "/usr/sap/S4H/hdbclient/hdbsql -U DEFAULT ""SELECT JOBNAME,BTCSYSREAX , SDLUNAME, STRTDATE,STRTTIME FROM TBTCO where STATUS='R' ORDER BY STRTDATE""",**{'async':0},timeout=30 )
		del a['lines']['item'][0]
		del a['lines']['item'][-1]
		del a['lines']['item'][-1]
		for i in a['lines']['item']:
			job = i.split(",")
			hanajobsuniqueid = uuid.uuid4()
			jobobj = Hanajobs(hanajobsuniqueid = hanajobsuniqueid.hex,customer_id = cusid,system_id = sysid,jobtype='Active Jobs',jobname=job[0],btcsysreax=job[1],sdluname=job[2],startdate=job[3],starttime=job[4],created_at= created_at,sub_by=sub_by,log_id=log_id)
			jobobj.save()

		a1 = client.service.OSExecute(command= "/usr/sap/S4H/hdbclient/hdbsql -U DEFAULT ""SELECT JOBNAME,BTCSYSREAX , SDLUNAME, STRTDATE, STRTTIME FROM TBTCO where STATUS='A' and STRTDATE=(to_char(CURRENT_DATE,'YYYYMMDD')) ORDER BY JOBNAME""",**{'async':0},timeout=30 )
		del a1['lines']['item'][0]
		for i in a1['lines']['item'][0:11]:
			job = i.split(",")
			hanajobsuniqueid = uuid.uuid4()
			jobobj = Hanajobs(hanajobsuniqueid = hanajobsuniqueid.hex,customer_id = cusid,system_id = sysid,jobtype='Cancelled Jobs',jobname=job[0],btcsysreax=job[1],sdluname=job[2],startdate=job[3],starttime=job[4],created_at= created_at,sub_by=sub_by,log_id=log_id)
			jobobj.save()


def workprocess(system_id,customer_id,email,wsdl,log_id,created_at):
	for i1 in wsdl:
		client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
		a = client.service.ABAPGetSystemWPTable()
		sysid = system_id
		cusid = customer_id
		sub_by = email
		# log_id = uuid.uuid4()
		# healthchechid = '9670762fee9f4d95b745559293b3f641'			
		for i in a:
			wpuniqueid = uuid.uuid4()
			Instance = i['Instance']
			No = i['No']
			Typ = i['Typ']
			Status = i['Status']
			Reason = i['Reason']
			Start = i['Start']
			Err = i['Err']
			Cpu = i['Cpu']
			Sem = i['Sem']
			Time = i['Time']
			Program = i['Program']
			Client = i['Client']
			User = i['User']
			Action = i['Action']
			Table = i['Table']
			wp = Workprocess(wpuniqueid = wpuniqueid.hex,customer_id = cusid,system_id = sysid,instance = Instance,no = No,typ = Typ,status = Status,reason = Reason,start = Start,err = Err,sem = Sem,cpu = Cpu,time = Time,program = Program,client = Client,user = User,action=Action,table = Table,created_at= created_at,sub_by=sub_by,log_id=log_id.hex)
			wp.save()

def memhealthcheck(system_id,customer_id,email,list_tree,log_id,created_at):
	sysid = system_id
	cusid = customer_id
	# memuniqueid = uuid.uuid4()
	# swapuniqueid = uuid.uuid4()
	# created_at = datetime.datetime.now()
	# log_id = uuid.uuid4()
	# healthchechid = '9670762fee9f4d95b745559293b3f621'
	sub_by = email
	for i in list_tree[0][1]['children']:
		if i['name']=='Memory':
			for j in i['children']:
				metric = j['name']
				value = j['description']
				memuniqueid = uuid.uuid4()	
				mem = Memorymetrics(memuniqueid=memuniqueid.hex,customer_id= cusid,system_id=sysid,metric = metric,value=value,created_at=created_at,log_id=log_id.hex)
				mem.save()
	# swap = Memorymetrics(memuniqueid=swapuniqueid.hex,customer_id= cusid,system_id=sysid,memtype = k1[0][0:-1],total= k1[1],used=k1[2],free =k1[3],shared='',cache='',available='',created_at=created_at)
	# swap.save()

def cpuhealthcheck(system_id,customer_id,email,list_tree,log_id,created_at):
	sysid = system_id
	cusid = customer_id
	#cpuuniqueid = uuid.uuid4()
	# swapuniqueid = uuid.uuid4()
	# created_at = datetime.datetime.now()
	# log_id = uuid.uuid4()
	# healthchechid = '9670762fee9f4d95b745559293b3f621'
	sub_by = email
	for i in list_tree[0][1]['children']:
		if i['name']=='CPU':
			for j in i['children']:
				metric = j['name']
				value = j['description']
				cpuuniqueid = uuid.uuid4()	
				cpu = Cpumetrics(cpuuniqueid=cpuuniqueid.hex,customer_id= cusid,system_id=sysid,metric = metric,value=value,created_at=created_at,log_id=log_id.hex)
				cpu.save()

def fshealthcheck(system_id,customer_id,email,list_tree,log_id,created_at):
	# a = client.service.OSExecute(command = "/usr/bin/df -h",**{'async':0},timeout=30 )
	sysid = system_id
	cusid = customer_id
	created_at = datetime.datetime.now()	
	sub_by = email
	# log_id = uuid.uuid4()
	# healthchechid = '9670762fee9f4d95b745559293b3f622'
	# k = (a['lines']['item'])
	# del k[0]
	for i in list_tree[0][1]['children']:
		if i['name'] == 'Filesystems':
			for j in i['children']:
				fsuniqueid = uuid.uuid4()	
				obj = []			
				for k in j['children']:  	
					obj.append(k['description'])
				fs = Fsmetircs(fsuniqueid=fsuniqueid.hex,customer_id= cusid,system_id=sysid,filesys = obj[0],free= obj[1],perc=obj[2],created_at=created_at,log_id=log_id.hex)
				fs.save()					

def bufferpool(system_id,customer_id,email,wsdl,log_id,created_at):
	ip = wsdl[0]['ip']
	dbport = wsdl[0]['dbport']
	sid = wsdl[0]['SID']
	dbpwd = wsdl[0]['dbpwd'] 
	sid_lower = sid.lower()
	db = (
	    "DRIVER=IBM DB2 ODBC DRIVER;" 
	    "DATABASE="+sid+";"
	    "HOSTNAME="+ip+";"
	    "PORT="+dbport+";"
	    "PROTOCAL=TCPIP;"
	    "UID=db2"+sid_lower+";"
	    "PWD="+dbpwd+";")	
	conn = ibm_db.connect(db,"","")
	stmt = ibm_db.exec_immediate(conn,"SELECT  SUBSTR(BP_NAME,1,14), TOTAL_HIT_RATIO_PERCENT,  DATA_HIT_RATIO_PERCENT,  INDEX_HIT_RATIO_PERCENT FROM SYSIBMADM.BP_HITRATIO where TOTAL_HIT_RATIO_PERCENT is not null")
	metrics = ['bpname','totalhrp','datahrp','indexhrp']
	sub_by = email
	sysid = system_id
	cusid = customer_id
	while ibm_db.fetch_row(stmt)!= False:
		for i in range(4):
			bpuniqid = uuid.uuid4()
			value = ibm_db.result(stmt,i)
			metric = metrics[i]
			inst = Bufferpool(bpuniqueid=bpuniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
			inst.save()	

def runtimedumps(system_id,customer_id,email,wsdl,log_id,created_at,list_trees,sub_by):
	for i1 in list_trees:
		created_at = created_at
		for i in i1[5]['children']:
			dumpsuniqueid = uuid.uuid4()
			metric = i['name']
			value = i['description']
			obj = Healthcheckruntimedumps(dumpsuniqueid=dumpsuniqueid.hex,customer_id= customer_id,system_id=system_id,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id.hex,instance_id = wsdl[0]['instance_id'])
			obj.save()
			# sql = "INSERT INTO healthcheckruntimedumps(dumpsuniqueid,customer_id,system_id,metric,value,created_at,instance_id,log_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
			# sql_value = (str(dumpsuniqueid),customer_id,system_id,metric,value,created_at,wsdl[0]['instance_id'],log_id)
			# mycursor.execute(sql,sql_value)
			# mydb.commit()

def responsetime(system_id,customer_id,email,wsdl,log_id,created_at,list_trees,sub_by):
	for i1 in list_trees:
		created_at = created_at
		for i in i1[3]['children']:
			if i['name'] == 'Dialog':
				for j in i['children']:
					responsetimeuniqueid = uuid.uuid4()
					metric = j['name']
					value = j['description']
					obj = Healthcheckresponsetimes(resuniqueid=responsetimeuniqueid.hex,customer_id= customer_id,system_id=system_id,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id.hex,instance_id = wsdl[0]['instance_id'])
					obj.save()
					# sql = "INSERT INTO healthcheckresponsetimes(resuniqueid,customer_id,system_id,metric,value,created_at,instance_id,log_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
					# sql_value =(str(responsetimeuniqueid),customer_id,system_id,metric,value,created_at,wsdl[0]['instance_id'],log_id)
					# mycursor.execute(sql,sql_value)
					# mydb.commit()	

def update(system_id,customer_id,email,wsdl,log_id,created_at,list_trees,sub_by):
	for i1 in list_trees:
		created_at = created_at
		for i in i1[3]['children']:
			if i['name'] == 'Update':
				for j in i['children']:
					updatetype = j['name']
					for k in j['children']:
						updateuniqueid = uuid.uuid4()
						metric = k['name']					
						value = k['description']
						obj = Healthcheckupdatemonitoring(updateuniqueid=updateuniqueid.hex,customer_id= customer_id,system_id=system_id,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id.hex,instance_id = wsdl[0]['instance_id'],updatetype=updatetype)
						obj.save()
						# sql = "INSERT INTO healthcheckupdatemonitoring(updateuniqueid,customer_id,system_id,updatetype,metric,value,created_at,instance_id,log_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s))"
						# sql_value = (str(updateuniqueid),customer_id,system_id,updatetype,metric,value,created_at,wsdl[0]['instance_id'],log_id)
						# mycursor.execute(sql,sql_value)
						# mydb.commit()
		
def buffer(system_id,customer_id,email,wsdl,log_id,created_at,list_trees,sub_by):
	for i1 in list_trees:
		created_at = created_at
		for i in i1[4]['children']:
			if i['name'] == 'Buffers':
				for j in i['children']:
					buffertype = j['name']
					for k in j['children']:
						bufferuniqueid = uuid.uuid4()
						metric = k['name']
						value = k['description']
						obj = Healthcheckbuffer(bufferuniqueid=bufferuniqueid.hex,customer_id= customer_id,system_id=system_id,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id.hex,instance_id = wsdl[0]['instance_id'],buffertype=buffertype)
						obj.save()
						# sql = "INSERT INTO healthcheckbuffer(bufferuniqueid,customer_id,system_id,buffertype,metric,value,created_at,instance_id,log_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s)"
						# sql_value = (str(bufferuniqueid),customer_id,system_id,buffertype,metric,value,created_at,wsdl[0]['instance_id'],log_id)		
						# mycursor.execute(sql,sql_value)
						# mydb.commit()

@api_view(['GET', 'POST'])
def ReportMail(request):
	if request.method == 'POST':
		log_id=request.data.get('logid')
		mailto=request.data.get('mailto')
		# cc=request.data.get('cc')
		log = Healthchecklogs.objects.filter(healthchecklogsuniqueid = log_id)	
		serializer = HealthchecklogsSerializer(log, many = True)
		path = serializer.data[0]['report_path']
		filename = serializer.data[0]['filename']
		try:
			sendmail(mailto,path,filename)
			flag = 1
		except:
			flag = 0
		return Response({'message':'Mail sent','flag':flag}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def SystemAdministrationLogs(request):
	if request.method == 'POST':
		cusid=request.data.get('cid')
		sysid=request.data.get('sid')
		wsdl = WSDL(sysid)
		output = []
		for i1 in wsdl:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
			a = client.service.GetSystemInstanceList()
			for j in a:
				dictionary = {}
				dictionary['hostname'] = j['hostname']
				dictionary['instanceNr'] = j['instanceNr']
				dictionary['httpPort'] = j['httpPort']
				dictionary['httpsPort'] = j['httpsPort']
				dictionary['startPriority'] = j['startPriority']
				dictionary['features'] = j['features']
				dictionary['dispstatus'] = j['dispstatus']
				output.append(dictionary)
		return Response({'output':output}, status=status.HTTP_200_OK)



@api_view(['GET', 'POST'])
def InstanceAdministrationLogs(request):
	if request.method == 'POST':
		cusid=request.data.get('cid')
		sysid=request.data.get('sid')
		instanceid = request.data.get('iid')
		wsdl = instWSDLsingle(sysid,instanceid)
		output = []
		for i1 in wsdl:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
			a = client.service.GetProcessList()
			for j in a:
				dictionary = {}
				dictionary['name'] = j['name']
				dictionary['description'] = j['description']
				dictionary['dispstatus'] = j['dispstatus']
				output.append(dictionary)							
		return Response({'output':output}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def runhealthcheck(request):
	if request.method == 'POST':
		cusid=request.data.get('cid')
		sysid=request.data.get('sid')
		email=request.data.get('run_by')
		healthcheck_id = request.data.get('healthcheck_id')
		created_at = datetime.datetime.now()
		log_id = uuid.uuid4()
		wsdl = WSDL(sysid)
		instwsdl = instWSDL(sysid)
		instw_abap = []
		for i in instwsdl:
			s = i['features'].split('|')
			if 'ABAP' in s:
				instw_abap.append(i)
		list_tree = list_currentalerts(wsdl)
		list_trees_abap = list_currentalerts(instw_abap)

		count = 0

		if healthcheck_id == '9670762fee9f4d95b745559293b3f623':

			try:
				workprocess(sysid,cusid,email,wsdl,log_id,created_at)
			except:
				count = count + 1
			
			try:	
				buffer(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1
			
			try:	
				runtimedumps(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1
			
			try:	
				responsetime(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1	

			try:	
				update(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1	
			
			#abaplogs(sysid,cusid,email,wsdl,log_id,created_at)

			#licence(sysid,cusid,email,wsdl,log_id,created_at)	
			if count >  0:
				log_status = 0
			else:
				log_status = 1	
			log = Healthchecklogs(healthchecklogsuniqueid=log_id.hex,customer_id= cusid,system_id=sysid,healthcheck_id = healthcheck_id,starttime = created_at,created_at=created_at,run_by=email,status = log_status)	    	
			log.save()
		
		elif healthcheck_id == '9670762fee9f4d95b745559293b3f645':

			try:
				memhealthcheck(sysid,cusid,email,list_tree,log_id,created_at)
			except:
				count = count + 1
			
			try:	
				cpuhealthcheck(sysid,cusid,email,list_tree,log_id,created_at)

			except:
				count = count + 1
			
			try:	
				fshealthcheck(sysid,cusid,email,list_tree,log_id,created_at)
			except:
				count = count + 1			
			
			if count >  0:
				log_status = 0
			else:
				log_status = 1	
			log = Healthchecklogs(healthchecklogsuniqueid=log_id.hex,customer_id= cusid,system_id=sysid,healthcheck_id = healthcheck_id,starttime = created_at,created_at=created_at,run_by=email,status = log_status)	    	
			log.save()	

		elif healthcheck_id == '9670762fee9f4d95b745559293b3f667':

			try:
				memhealthcheck(sysid,cusid,email,list_tree,log_id,created_at)
			except:
				count = count + 1
			
			try:	
				cpuhealthcheck(sysid,cusid,email,list_tree,log_id,created_at)

			except:
				count = count + 1
			
			try:	
				fshealthcheck(sysid,cusid,email,list_tree,log_id,created_at)
			except:
				count = count + 1	

			try:
				workprocess(sysid,cusid,email,wsdl,log_id,created_at)
			except:
				count = count + 1
			
			try:	
				buffer(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1
			
			try:	
				runtimedumps(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1
			
			try:	
				responsetime(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1	

			try:	
				update(sysid,cusid,email,instw_abap,log_id,created_at,list_trees_abap,email)
			except:
				count = count + 1	

			#abaplogs(sysid,cusid,email,wsdl,log_id,created_at)

			#licence(sysid,cusid,email,wsdl,log_id,created_at)	
			
			if wsdl[0]['dbtype'] == "DB2":
				db_instance_details(sysid,cusid,email,wsdl,log_id,created_at)

				bufferpool(sysid,cusid,email,wsdl,log_id,created_at)

				# runstats(sysid,cusid,email,wsdl,log_id,created_at)

				Lockwaits(sysid,cusid,email,wsdl,log_id,created_at)

				activelogs(sysid,cusid,email,wsdl,log_id,created_at)

			elif wsdl[0]['dbtype'] == "HANA":	
				# hanadbalerts(sysid,cusid,email,wsdl,log_id,created_at)
				try:
					hanajobs(sysid,cusid,email,wsdl,log_id,created_at)
				except:
					count = count +1	

			if count >  0:
				log_status = 0
			else:
				log_status = 1
			log = Healthchecklogs(healthchecklogsuniqueid=log_id.hex,customer_id= cusid,system_id=sysid,healthcheck_id = healthcheck_id,starttime = created_at,created_at=created_at,run_by=email,status = log_status)	    	
			log.save()	

		elif healthcheck_id == '9670762fee9f4d95b745559293b3f612':
			if wsdl[0]['dbtype'] == "DB2":
				db_instance_details(sysid,cusid,email,wsdl,log_id,created_at)

				bufferpool(sysid,cusid,email,wsdl,log_id,created_at)

				# runstats(sysid,cusid,email,wsdl,log_id,created_at)

				Lockwaits(sysid,cusid,email,wsdl,log_id,created_at)

				activelogs(sysid,cusid,email,wsdl,log_id,created_at)

			elif wsdl[0]['dbtype'] == "HANA":	
				# hanadbalerts(sysid,cusid,email,wsdl,log_id,created_at)
				
				try:
					hanajobs(sysid,cusid,email,wsdl,log_id,created_at)
				except:
					count = count +1	

			if count >  0:
				log_status = 0
			else:
				log_status = 1
			log = Healthchecklogs(healthchecklogsuniqueid=log_id.hex,customer_id= cusid,system_id=sysid,healthcheck_id = healthcheck_id,starttime = created_at,created_at=created_at,run_by=email,status = log_status)	    	
			log.save()
		generatereport(healthcheck_id,log_id.hex,sysid)
			
		return Response({'output':'Success'}, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def systemadministration(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		flag = request.data.get('flag')
		wsdl = WSDL(systemId)
		created_at = datetime.datetime.now()
		sysadminlogsuniqueid = uuid.uuid4()
		email=request.data.get('run_by')
		for i1 in wsdl:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
			if int(flag) == 1:
				a = client.service.StartSystem(options = 0,waittimeout = 0,prioritylevel=1)
				action = "StartSystem"
				output = {"message":"Start System action successful"}
			elif int(flag) == 0:
				a = client.service.StopSystem(options = 0,waittimeout = 0,softtimeout=0,prioritylevel=1)
				action = "StopSystem"	
				output = {"message":"Stop System action successful"}
		action_status = 1
		log = Sysadminlogs(sysadminlogsuniqueid=sysadminlogsuniqueid.hex,customer_id= customerId,system_id=systemId,action=action,created_at=created_at,run_by=email,status = action_status)	
		log.save()

		return Response(output, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def instanceadministration(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		instanceId = request.data.get('iid')
		flag = request.data.get('flag')
		wsdl = instWSDLsingle(systemId,instanceId)
		created_at = datetime.datetime.now()
		sysadminlogsinstanceuniqueid = uuid.uuid4()
		email=request.data.get('run_by')
		for i1 in wsdl:
			client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
			if int(flag) == 1:
				a = client.service.Start()
				action = "StartInstance"
				output = {"message":"Start instance action successful"}
			elif int(flag) == 0:	
				a = client.service.Stop()
				action = "StopInstance"
				output = {"message":"Stop instance action successful"}
		action_status = 1
		log = Sysadminlogsinstance(sysadminlogsinstanceuniqueid=sysadminlogsinstanceuniqueid.hex,customer_id= customerId,system_id=systemId,action=action,created_at=created_at,run_by=email,status = action_status,instance_id = instanceId)	
		log.save()

		return Response(output, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetInstInfoById(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		metrics = Instancelist.objects.filter(customer_id = customerId).filter(insuniqueid = instanceId)
		serializer = InstSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

def check_sys_connectivity(swsdl,uid,pwd):
	checksession = Session()
	checksession.auth = HTTPBasicAuth(uid,pwd)
	checksession.verify = False
	checktransport = Transport(session=checksession)
	sysconnclient = Client(wsdl=swsdl, transport=checktransport)
	out_alert_tree = sysconnclient.service.GetAlertTree()
	if len(out_alert_tree)>0:
		a = client.service.GetProcessList()
		if a[0]['textstatus'] == 'Running':
			status = 1
		elif a[0]['textstatus'] == 'Stopped':	
			status = 2
		else:
			status = 0	
	else:
		status = 'Not able to Connect'
	return status	


# @api_view(['GET','POST'])
# def healthcheckschedule()
# 	if request.method == 'POST':
# 		cusid=request.data.get('cid')
# 		sysid=request.data.get('sid')
# 		email=request.data.get('run_by')
# 		healthcheck_id = request.data.get('healthcheck_id')
# 		time = request.data.get('time')
# 		created_at = datetime.datetime.now()
# 		log_id = uuid.uuid4()
# 		wsdl = WSDL(sysid)
# 		instwsdl = instWSDL(sysid)
# 		list_tree = list_currentalerts(wsdl)

@api_view(['GET','POST'])
def healthcheckgraph(request):
	if request.method == 'POST':
		cusid = request.data.get('cid')
		healthchecklogs = Healthchecklogs.objects.filter(customer_id = cusid)
		logsserializer = HealthchecklogsSerializer(healthchecklogs, many = True)
		today = datetime.datetime.now()
		today_modified = datetime.datetime(today.year,today.month,today.day)		
		total = 0
		completed = 0
		scheduled = 0
		failed = 0
		for i in logsserializer.data:
			run_at = datetime.datetime.strptime(i['starttime'],"%Y-%m-%d %H:%M:%S.%f")
			run_at_modified = datetime.datetime(run_at.year,run_at.month,run_at.day)

			if run_at.day==today.day:
				if int(i['status']) == 1:
					completed = completed + 1
				elif int(i['status']) == 0:
					failed = failed + 1
				elif int(i['status']) == 2:
					scheduled = scheduled + 1
			else:
				total = -1
		total = completed + failed + scheduled
		output = {"total" : total,"completed" : completed,"failed" : failed,"scheduled" : scheduled}
		return Response(output,status = status.HTTP_200_OK)					



@api_view(['GET','POST'])
def dashboardmetricscount(request):
	if request.method == 'POST':
		cusid = request.data.get('cid')
		systemcount = SystemsV2.objects.filter(customer_id = cusid).exclude(status = 3)
		instcount = Instancelist.objects.filter(customer_id = cusid).exclude(status = 3)
		sol = SystemsV2.objects.filter(customer_id = cusid).exclude(status = 3).values('solution_id')
		serializer = SystemsV2Serializer(systemcount, many = True)
		healthchecklogs = Healthchecklogs.objects.filter(customer_id = cusid)
		logsserializer = HealthchecklogsSerializer(healthchecklogs, many = True)
		logs_count_month = 0
		logs_count_week = 0
		logs_count_day = 0
		up = 0
		down = 0
		partiallyup = 0
		temp =[]
		instance_count_db = 0
		today = datetime.datetime.now()
		yesterday = today - datetime.timedelta(days = 1)
		week = today - datetime.timedelta(days = 7)
		last_month = today - datetime.timedelta(days = 30)
		yesterday_modified = datetime.datetime(yesterday.year,yesterday.month,yesterday.day)
		week_modified = datetime.datetime(week.year,week.month,week.day)
		last_month_modified = datetime.datetime(last_month.year,last_month.month,last_month.day)

		for i in logsserializer.data:
			run_at = datetime.datetime.strptime(i['starttime'],"%Y-%m-%d %H:%M:%S.%f")
			run_at_modified = datetime.datetime(run_at.year,run_at.month,run_at.day)

			if run_at_modified>yesterday_modified:
				logs_count_day = logs_count_day + 1

			if run_at_modified>week_modified:
				logs_count_week = logs_count_week + 1

			if run_at_modified>last_month_modified:
				logs_count_month = logs_count_month + 1


		for i in sol:
			temp.append(i['solution_id'])
		for i in serializer.data:
			if i['instancetype'] == 'DB_Application':
				instance_count_db = instance_count_db + 1
			if i['status'] == '1':
				up = up + 1
			elif i['status'] == '0':
				down = down + 1
			elif i['status'] == '2':
				partiallyup = partiallyup + 1	
		output = {'syscount' : len(systemcount),'instcount' : len(instcount) ,'solutioncount':len(set(temp)),'up':up,'down':down,'partiallyup':partiallyup ,'healthcheckcount_day':logs_count_day,'healthcheckcount_week':logs_count_week,'healthcheckcount_month':logs_count_month}
		return Response(output,status = status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"},status = status.HTTP_400_BAD_REQUEST)

@api_view(['GET','POST'])
def CustomerList(request):
	if request.method == 'GET':
		CustDetails = CustomerMang.objects.all()
		serializer = CustomerMangSerializer(CustDetails, many = True)
		return Response(serializer.data,status = status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"},status = status.HTTP_400_BAD_REQUEST)	

@api_view(['GET', 'POST'])
def GetSystems(request):
	if request.method == 'POST':
		uniqueId=request.data.get('id')

		SystemDetails = Systems.objects.filter(customer_id = uniqueId)
		serializer = SystemsSerializer(SystemDetails, many = True)
		if (len(serializer.data)>0):
			return Response(serializer.data, status=status.HTTP_200_OK)
		else:
			return Response({"message" : "Either Customer Id is Wrong or No Systems under the Customer"}, status=status.HTTP_404_NOT_FOUND)	
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)	


@api_view(['GET', 'POST'])
def GetSystemsnew(request):
	if request.method == 'POST':
		uniqueId=request.data.get('id')

		SystemDetails = SystemsV2.objects.filter(customer_id = uniqueId).exclude(status =3)
		serializer = SystemsV2Serializer(SystemDetails, many = True)
		if (len(serializer.data)>0):
			return Response(serializer.data, status=status.HTTP_200_OK)
		else:
			return Response({"message" : "Either Customer Id is Wrong or No Systems under the Customer"}, status=status.HTTP_200_OK)	
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def GetCustomerInfobyId(request):
	if request.method == 'POST':
		customerId=request.data.get('cid')
		customer_obj = CustomerMang.objects.filter(cusuniqueid = customerId)
		serializer = CustomerMangSerializer(customer_obj, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetUserInfobyId(request):
	if request.method == 'POST':
		userId=request.data.get('uid')
		user_obj = Usermanagement.objects.filter(useruniqueid = userId)
		serializer = UsermanagementSerializer(user_obj, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
@api_view(['GET', 'POST'])
def SystemDetailsValidate(request):
	if request.method == 'POST':
		ip=request.data.get('ip')
		sid=request.data.get('sidadm')
		port=request.data.get('port')
		pwd=request.data.get('pwd')
		wsdl = 'http://' + ip + ':' + port + '/?wsdl'
		flag = 0
		try:
			client = ConnectionValidate(wsdl,sid,pwd)
			try:
				alert_tree = client.service.GetAlertTree()
				message = "Success"
				flag = 1
			except:
				message = "Invalid SID/Password"
		except:
			message = "Please Check IP/Port/NetworkConfig "
		return Response({"message":message,"flag":flag}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Getkpi(request):
    if request.method == 'POST':
        customerId = request.data.get('cid')
        metrics = Kpi.objects.filter(customer_id = customerId)
        serializer = KpiSerializer(metrics, many = True)
        return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetSystemsbyId(request):
        if request.method == 'POST':
                customerId = request.data.get('cid')
                systemId = request.data.get('sid')


                SystemDetailsId = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).exclude(status = 3)
                solid = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('solution_id')[0]['solution_id']
                serializer = SystemsIdSerializer(SystemDetailsId, many = True)

                serializer.data[0]['solname'] = solutionname(solid)
                return Response(serializer.data, status=status.HTTP_200_OK)
        else:
        	return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)	       

@api_view(['GET','POST'])
def HealthcheckList(request):
	if request.method == 'GET':
		healthcheckobj = Healthcheck.objects.all()
		serializer = HealthcheckSerializer(healthcheckobj, many = True)
		return Response(serializer.data,status = status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"},status = status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def Getinstinfo(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbappinstancelist.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbInstSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Gettreedata(request):
	if request.method == 'POST':
		systemId = request.data.get('sid')
		# print(systemId)
		timestamp = Alerttree.objects.order_by('-id').filter(system_id = systemId).values('created_at')[0]['created_at']
		metrics = Alerttree.objects.filter(system_id = systemId).filter(created_at = timestamp)
		serializer = TreeSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)



@api_view(['GET', 'POST'])

#assume that the system time matches with the server time
#we run the sla scheduler once a day at 12 am

def GetSla(request):
	if request.method == 'POST':
		dumps = json.dumps(request.data)
		dict = json.loads(dumps)
		customerId = dict['cid']
		solution_id = dict['solutionid']
		system_id = dict['systemIds']
		flag = dict['flag']
		# print(type(flag))
		# print(flag)
		# print(customerId,solution_id,system_id)
		temp1 = []
		temp2 = []
		created_at = []
		system_ids = []
		# created_at = datetime.datetime(2021,9,16)
		mdown = 0
		mup = 0
		wup = 0
		wdown = 0
		up = 0
		down = 0		
		today = datetime.datetime.now()
		week = today - datetime.timedelta(days = 7)
		last_month = today - datetime.timedelta(days = 31)
		# print(last_month)
		today_modified = datetime.datetime(today.year,today.month,today.day)
		week_modified = datetime.datetime(week.year,week.month,week.day)
		last_month_modified = datetime.datetime(last_month.year,last_month.month,last_month.day)

		logs_month_available = []
		logs_week_available = []
		logs_day_available = []
		logs_month_unavailable = []
		logs_week_unavailable = []
		logs_day_unavailable = []	
		if int(flag)==1:
			slafilterobj = Sla.objects.filter(customer_id = customerId)
			obj = SlafilterSerializer(slafilterobj, many = True)
			for i in obj.data:
				temp1.append(i['system_id'])
				temp2.append(i['created_at'])
				system_ids = list(set(temp1))
				created_at = list(set(temp2))
			# print(created_at)		
			for i in range(len(system_ids)):	
				created_at_formated = datetime.datetime.strptime(created_at[i],"%Y-%m-%d %H:%M:%S.%f")
				# created_at_formated = created_at_formated + datetime.timedelta(days = 1)
				metrics = Slaold.objects.filter(customer_id = customerId).filter(system_id=system_ids[i]).filter(modified_at__gt=created_at_formated)
				serializer = SlaoldSerializer(metrics, many = True)
				
				for i in serializer.data:
					stime = datetime.datetime.strptime(i['stime'],"%d.%m.%Y %H:%M:%S")
					stime_modified = datetime.datetime(stime.year,stime.month,stime.day)
					etime = datetime.datetime.strptime(i['etime'],"%d.%m.%Y %H:%M:%S")
					etime_modified = datetime.datetime(etime.year,etime.month,etime.day)
					time_delta = (etime - stime)
					total_seconds = time_delta.total_seconds()
					minutes = total_seconds/3600
					if stime_modified>last_month_modified:
						if i['slastatus'] == 'Unavailable':
							mdown = mdown + minutes
							logs_month_unavailable.append(i)
						else :
							mup = mup + minutes
							logs_month_available.append(i)
					if stime_modified==today_modified:
						if i['slastatus'] == 'Unavailable':
							down = down + minutes	
							logs_day_unavailable.append(i)					
						else:
							up = up + minutes	
							logs_day_available.append(i)					
					if stime_modified>week_modified:
						if i['slastatus'] == 'Unavailable':
							wdown = wdown + minutes	
							logs_week_unavailable.append(i)					
						else:
							wup = wup + minutes	
							logs_week_available.append(i)					

			output = {'solutionname':'HANA','mdown':mdown,'mup':mup,'wdown':wdown,'wup':wup,'up':up,'down':down,'logs_month_available':logs_month_available,'logs_month_unavailable':logs_month_unavailable,'logs_week_available':logs_week_available,'logs_week_unavailable':logs_week_unavailable,'logs_day_available':logs_day_available,'logs_day_unavailable':logs_day_unavailable}
		
		elif flag==0:

			slafilterobj = Sla.objects.filter(customer_id = customerId).filter(solution_id=solution_id)
			obj = SlafilterSerializer(slafilterobj, many = True)
			for i in obj.data:
				temp1.append(i['system_id'])
				temp2.append(i['created_at'])
				system_ids = list(set(temp1))
				created_at = list(set(temp2))
			for i in range(len(system_ids)):	
				created_at_formated = datetime.datetime.strptime(created_at[i],"%Y-%m-%d %H:%M:%S.%f")
				created_at_formated = created_at_formated + datetime.timedelta(days = 1)				
				metrics = Slaold.objects.filter(customer_id = customerId).filter(system_id=system_ids[i]).filter(modified_at__gt=created_at[i])
				serializer = SlaoldSerializer(metrics, many = True)
				
				for i in serializer.data:
					stime = datetime.datetime.strptime(i['stime'],"%d.%m.%Y %H:%M:%S")
					stime_modified = datetime.datetime(stime.year,stime.month,stime.day)
					etime = datetime.datetime.strptime(i['etime'],"%d.%m.%Y %H:%M:%S")
					etime_modified = datetime.datetime(etime.year,etime.month,etime.day)
					time_delta = (etime - stime)
					total_seconds = time_delta.total_seconds()
					minutes = total_seconds/3600
					if stime_modified>last_month_modified:
						if i['slastatus'] == 'Unavailable':
							mdown = mdown + minutes
							logs_month_unavailable.append(i)
						else :
							mup = mup + minutes
							logs_month_available.append(i)
					if stime_modified==today_modified:
						if i['slastatus'] == 'Unavailable':
							down = down + minutes	
							logs_day_unavailable.append(i)					
						else:
							up = up + minutes	
							logs_day_available.append(i)					
					if stime_modified>week_modified:
						if i['slastatus'] == 'Unavailable':
							wdown = wdown + minutes	
							logs_week_unavailable.append(i)					
						else:
							wup = wup + minutes	
							logs_week_available.append(i)					

			output = {'solutionname':'HANA','mdown':mdown,'mup':mup,'wdown':wdown,'wup':wup,'up':up,'down':down,'logs_month_available':logs_month_available,'logs_month_unavailable':logs_month_unavailable,'logs_week_available':logs_week_available,'logs_week_unavailable':logs_week_unavailable,'logs_day_available':logs_day_available,'logs_day_unavailable':logs_day_unavailable}
						
		return Response(output, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetCPU(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')

		timestamp = Cpumonitoring.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Cpumonitoring.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = CpumonitoringSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetFS(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		
		timestamp = Fsmonitoring.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Fsmonitoring.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = FsmonitoringSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Getworkprocessmonitoring(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		
		timestamp = Workprocessmonitoring.objects.order_by('-id').filter(system_id = systemId).values('created_at')[0]['created_at']

		metrics = Workprocessmonitoring.objects.filter(customer_id = customerId).filter(system_id = systemId).filter(created_at = timestamp)

		serializer = WorkprocessmonitoringSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetMem(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		
		timestamp = Memorymonitoring.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Memorymonitoring.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = MemorymonitoringSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetProcess(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		timestamp = ProcessList.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']
		metrics = ProcessList.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = ProcessSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def SolutionList(request):
	if request.method == 'POST':
		cusid = request.data.get('cid')
		solutionlist = SystemsV2.objects.filter(customer_id = cusid).exclude(status =3).values('solution_id').distinct()

		serializer = SolutionlistSerializer(solutionlist, many = True)
		for i in serializer.data:
			i['solname'] = solutionname(i['solution_id'])
		
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetInst(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		ip = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('ip')[0]['ip']
		systemname = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('sysname')[0]['sysname']
		metrics = Instancelist.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = InstSerializer(metrics, many = True)
		for i in serializer.data:
			timestamp = ProcessList.objects.order_by('-id').filter(instance_id = i['insuniqueid']).values('created_at')[0]['created_at']
			processmetrics = ProcessList.objects.filter(customer_id = customerId).filter(instance_id = i['insuniqueid']).filter(created_at = timestamp)
			processserializer = ProcessSerializer(processmetrics, many = True)
			i['processlist'] = processserializer.data
			i['sname'] = systemname
			i['ip'] = ip		
		return Response(serializer.data, status=status.HTTP_200_OK)								

@api_view(['GET', 'POST'])
def GetInstAll(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		
		metrics = Instancelist.objects.filter(customer_id = customerId).exclude(status =3)

		serializer = InstSerializer(metrics, many = True)
		for i in serializer.data:
			ip = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = i['system_id']).values('ip')[0]['ip']
			systemname = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = i['system_id']).values('sysname')[0]['sysname']

			i['sname'] = systemname
			i['ip'] = ip
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetBuffermonitoring(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		
		timestamp = Buffer.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Buffer.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = BufferSerializer(metrics, many = True)

		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetRunTimeDumpsMonitoring(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		
		timestamp = Runtimedumps.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Runtimedumps.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = RuntimedumpsSerializer(metrics, many = True)

		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetResponsetimesmonitoring(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		
		timestamp = Responsetimes.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Responsetimes.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = ResponsetimesSerializer(metrics, many = True)

		return Response(serializer.data, status=status.HTTP_200_OK)	

@api_view(['GET', 'POST'])
def GetUpdatemonitoring(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		
		timestamp = Updatemonitoring.objects.order_by('-id').filter(instance_id = instanceId).values('created_at')[0]['created_at']

		metrics = Updatemonitoring.objects.filter(customer_id = customerId).filter(instance_id = instanceId).filter(created_at = timestamp)

		serializer = UpdatemonitoringSerializer(metrics, many = True)

		return Response(serializer.data, status=status.HTTP_200_OK)	

@api_view(['GET', 'POST'])
def Getusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')

		metrics = Usermanagement.objects.filter(customer_id = customerId).exclude(status =3)

		serializer = UsermanagementSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Getroles(request):
	if request.method == 'POST':
		metrics = Rolemang.objects.all()

		serializer = RolemangSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def Addusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		sub_by = request.data.get('sub_by')
		email = request.data.get('email')
		fname = request.data.get('fname')
		lname = request.data.get('lname')
		# roles = request.data.get('roles')
		pwd = request.data.get('pwd')
		hashAndSalt = bcrypt.hashpw(pwd.encode(), bcrypt.gensalt()) 
		fpwd = hashAndSalt.decode('utf8')
		mob = request.data.get('mob')
		role_id = request.data.get('role_id')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		isverified = 1
		user_status = 1	
		useruniqueid = uuid.uuid4()	
		obj = Rolemang.objects.get(roleuniqueid=role_id)
		rolename = obj.rolename
		user = Usermanagement(useruniqueid = useruniqueid.hex,customer_id = customerId,fname = fname,lname=lname,email = email,password = fpwd,role=rolename,isverified=isverified,status=user_status,sub_by=sub_by,created_at = created_at,modified_at = modified_at,mobilenum = mob,role_id = role_id)	
		user.save()
		return Response({'result':'User Added'}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Editusers(request):
	if request.method == 'POST':
		user_id = request.data.get('userid')
		userobj = Usermanagement.objects.get(useruniqueid = user_id)
		userobj.sub_by = request.data.get('sub_by')
		userobj.email = request.data.get('email')
		userobj.fname = request.data.get('fname')
		userobj.lname = request.data.get('lname')
		userobj.mob = request.data.get('mob')
		userobj.modified_at = datetime.datetime.now()	
		role_id = request.data.get('role_id')
		obj = Rolemang.objects.get(roleuniqueid=role_id)
		userobj.rolename = obj.rolename	
		userobj.save()
		return Response({'result':'User Updated'}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Delusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		userId = request.data.get('uid')
		user = Usermanagement.objects.get(useruniqueid = userId)
		
		# user.values('status')[0]['status'] = 3
		user.status = 3
		user.save()
		return Response({'result':'User Deleted'}, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def Lockusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		userId = request.data.get('uid')
		user = Usermanagement.objects.get(useruniqueid = userId)
		user.status = 4
		user.save()
		return Response({'result':'User Locked'}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Lockcustomer(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		customer = CustomerMang.objects.get(cusuniqueid = customerId)
		customer.status = 4
		customer.save()
		return Response({'result':'Customer Locked'}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def UnLockusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		userId = request.data.get('uid')
		user = Usermanagement.objects.get(useruniqueid = userId)
		user.status = 1
		user.save()
		return Response({'result':'User Locked'}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def UnLockcustomer(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		customer = CustomerMang.objects.get(cusuniqueid = customerId)
		customer.status = 1
		customer.save()
		return Response({'result':'Customer Locked'}, status=status.HTTP_200_OK)

@api_view(['POST'])
def Delsystems(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		system = SystemsV2.objects.get(sysuniqueid = systemId)
		
		system.status = 3
		system.save()

		instances = Instancelist.objects.filter(customer_id = customerId).filter(system_id = systemId).update(status = 3)
		instances.save()

		wsdl = Systemwsdl.objects.filter(customer_id = customerId).filter(system_id = systemId).update(status = 3)
		wsdl.save()

		return Response({'result':instances}, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def GetSpool(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')

		metrics = Spool.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = SpoolSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
				


@api_view(['GET', 'POST'])
def GetSol(request):
	if request.method == 'POST':
		start = time.time()
		customerId = request.data.get('id')
		

		metrics = Sapsolution.objects.filter(customer_id = customerId)

		serializer = SolSerializer(metrics, many = True)
		end = time.time()
		print(end-start)

		return Response(serializer.data, status=status.HTTP_200_OK)	
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)							

@api_view(['GET', 'POST'])
def Getsysbysolid(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		solutionId = request.data.get('solutionid')
		

		metrics = SystemsV2.objects.filter(customer_id = customerId).filter(solution_id = solutionId).exclude(status = 3)

		serializer = SystemsV2Serializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

def solutionname(id):
	name = Sapsolution.objects.filter(soluniqueid = id).values('solname')[0]['solname']
	return name

# def instancelistsingle(ip,sid,pwd,sysid,cusid,wsd):
# 	instsession = Session()
# 	instsession.auth = HTTPBasicAuth(sid,pwd)
# 	instsession.verify = True
# 	transport = Transport(session=instsession)
# 	instclient = Client(wsdl=wsd, transport=transport)

# 	a = instclient.service.GetSystemInstanceList()
# 	for j in a:
# 		sysname = j['hostname']
# 		instanceno = j['instanceNr']
# 		http_port = j['httpPort']
# 		https_port = j['httpsPort']
# 		start_priority = j['startPriority']
# 		features = j['features']
# 		status = j['dispstatus']
# 		wsdl ='http://' + ip + ':' + str(http_port) + '/?wsdl'
# 		created_at = datetime.now()
# 		insuniqueid = uuid.uuid4()
# 		modified_at = datetime.now()
# 		instancename = sysname + '_' + str(instanceno)
# 		insc = Instancelist(insuniqueid = insuniqueid.hex,system_id = sysid,customer_id = cusid,sysname = sysname,instanceno=instanceno,http_port = http_port,https_port = https_port,start_priority=start_priority,instancewsdlurl=wsdl,features=features,status=status,created_at = created_at,modified_at = modified_at,instaname = instancename)	
# 		insc.save()
# 		processlistsingle(wsdl,sid,pwd,sysid,cusid,insuniqueid.hex)	

def instancelistsingle(ip,sid,pwd,sysid,cusid,wsd):
        instsession = Session()
        instsession.auth = HTTPBasicAuth(sid,pwd)
        instsession.verify = True
        transport = Transport(session=instsession)
        instclient = Client(wsdl=wsd, transport=transport)

        a = instclient.service.GetSystemInstanceList()
        for j in a:
                sysname = j['hostname']
                instanceno = j['instanceNr']
                http_port = j['httpPort']
                https_port = j['httpsPort']
                start_priority = j['startPriority']
                features = j['features']
                status = j['dispstatus']
                if status == "SAPControl-GREEN":
                        insstatus = 1
                elif status == "SAPControl-YELLOw":
                        insstatus = 2
                else:
                        insstatus = 0
                wsdl ='http://' + ip + ':' + str(http_port) + '/?wsdl'
                created_at = datetime.datetime.now()
                insuniqueid = uuid.uuid4()
                modified_at = datetime.datetime.now()
                instancename = sysname + '_' + str(instanceno)
                insc = Instancelist(insuniqueid = insuniqueid.hex,system_id = sysid,customer_id = cusid,sysname = sysname,instanceno=instanceno,http_port = http_port,https_port = https_port,start_priority=start_priority,instancewsdlurl=wsdl,features=features,status=insstatus,created_at = created_at,modified_at = modified_at,instaname = instancename)
                insc.save()
                processlistsingle(wsdl,sid,pwd,sysid,cusid,insuniqueid.hex)

def exec_full(filepath):
	global_namespace = {
	"__file__": filepath,
	"__name__": "__main__",
	}
	with open(filepath, 'rb') as file:
		exec(compile(file.read(), filepath, 'exec'), global_namespace)

def processlistsingle(wsdl,sid,pwd,sysid,cusid,iid):
	processsession = Session()
	processsession.auth = HTTPBasicAuth(sid,pwd)
	processsession.verify = True
	transport = Transport(session=processsession)
	processclient = Client(wsdl=wsdl, transport=transport)
	a = processclient.service.GetProcessList()
	for j in a:
		name = j['name']
		description = j['description']
		dispstatus = j['dispstatus']
		starttime = j['starttime']
		if starttime is None:
			time=0
		else:	
			k = starttime.split()
			l1 = k[0:-1]
			s = '-'
			s = s.join(l1)
			time = s + ' ' + k[-1]
		
		created_at = datetime.datetime.now()
		processuniqueid = uuid.uuid4()	
		process = ProcessList(processuniqueid = processuniqueid.hex,system_id = sysid,customer_id = cusid,pname = name,pdesc=description,dispstatus = dispstatus,stime = time,created_at = created_at,instance_id =iid)	
		process.save()
	exec_full("/var/www/html/caremigration/schedulers.py")
# def slasingle(wsdl,sid,pwd,sysid,cusid):
# 	slasession = Session()
# 	treesession.auth = HTTPBasicAuth(sid,pwd)
# 	treesession.verify = True
# 	transport = Transport(session=treesession)
# 	treeclient = Client(wsdl=wsdl, transport=transport)
# 	a = treeclient.service.GetProcessList()


def currentalerts(wsdl,sid,pwd,sysid,cusid):
	treesession = Session()
	treesession.auth = HTTPBasicAuth(sid,pwd)
	treesession.verify = True
	transport = Transport(session=treesession)
	treeclient = Client(wsdl=wsdl, transport=transport)
	a = treeclient.service.GetAlertTree()
	for i in a:
		if i['parent'] ==-1:
			i['parent'] = ""
		
		if i['name'] == None:
			i['name'] = "None"

		if i['parent'] == None:
			i['parent'] = "None"

		if i['ActualValue'] == None:
			i['ActualValue'] = "None"

		if i['description'] == None:
			i['description'] = "None"

		if i['Time'] == None:
			i['Time'] = "None"

		if i['AnalyseTool'] == None:
			i['AnalyseTool'] = "None"

		if i['VisibleLevel'] == None:
			i['VisibleLevel'] = "None"

		if i['HighAlertValue'] == None:
			i['HighAlertValue'] = "None"

		if i['AlDescription'] == None:
			i['AlDescription'] = "None"

		if i['AlTime'] == None:
			i['AlTime'] = "None"

		if i['Tid'] == None:
			i['Tid'] = "None"

	new_a = []
	dictionary = {}
	for i in a:
		dictionary = {}
		dictionary['name'] = i['name']
		dictionary['parent'] = i['parent']
		dictionary['ActualValue'] = i['ActualValue']
		dictionary['description'] = i['description']
		dictionary['Time'] = i['Time']
		dictionary['AnalyseTool'] = i['AnalyseTool']
		dictionary['VisibleLevel'] = i['VisibleLevel']
		dictionary['HighAlertValue'] = i['HighAlertValue']
		dictionary['AlDescription'] = i['AlDescription']
		dictionary['AlTime'] = i['AlTime']
		dictionary['Tid'] = i['Tid']
		new_a.append(dictionary)


	tree = []
	list_ind = []
	for i in new_a:
	    ind = new_a.index(i)
	    i['Id'] = ind
	    list_ind.append(i)

	mappedarr = {}
	for i in list_ind:
	    Id  = i['Id']
	    if Id not in mappedarr.keys():
	        mappedarr[Id] = i
	        mappedarr[Id]['children'] = []

	    
	for i in mappedarr.keys():
	    mappedelement = mappedarr[i]

	    if mappedelement['parent']:
	        parentid = mappedelement['parent']
	        (mappedarr[parentid]['children']).append(mappedelement)

	    else:
	        tree.append(mappedelement)    
	treeuniqueid = uuid.uuid4()	        
	# json_res = json.dumps(tree[1], indent = 4)
	# newString = json.replace("\'", '"')
	created_at = datetime.datetime.now()
	treeobject = Alerttree(treeuniqueid = treeuniqueid.hex,system_id = sysid,customer_id = cusid,tree = tree[1],created_at = created_at)	
	treeobject.save()


@api_view(['POST'])
def sysadd(request):
	if request.method == 'POST':
			cipher_suite = Fernet(key)
			formData = request.data.get("data") 
			envname = formData['environmentselected'] 
			envtype = formData['environmentTypeSelected'] 
			insttype = formData['instanceTypeSelected'] 
			systype= formData['systemTypeSelected'] 
			solution_id = formData['solutionselected']
			systemsinfo = formData['systemsinfo']
			customer_id = formData['customer_id']
			sub_by = formData['sub_by']
			
			solname = solutionname(solution_id)
			sysname = envtype + '_' + solname + '_' + systype

			for i in systemsinfo:
				system_id = uuid.uuid4()
				ostype = i['ostype']
				dbtype = i['dbtype']
				sid = i['sid']
				ip = i['ip']
				pwd = i['password']
				port = i['port']
				osversion = i['osversion']
				appuid = i['appuid']
				dbuid = i['dbuid']
				dbversion = i['dbversion']
				dbpassword = i['dbpassword']
				encryprtedpwd = cipher_suite.encrypt(str.encode(pwd))
				dbencryprtedpwd = cipher_suite.encrypt(str.encode(dbpassword))
				finalencryprtedpwd = encryprtedpwd.decode()
				finaldbencryprtedpwd = dbencryprtedpwd.decode()
				created_at = datetime.datetime.now()
				modified_at =datetime.datetime.now()	
				sywsdluniqueid = uuid.uuid4()
				sysname = sysname + '_' + sid
				wsdl = 'http://' + ip + ':' + port + '/?wsdl' 			
				instance = SystemsNew(sysuniqueid = system_id.hex,customer_id = customer_id,solution_id = solution_id,sysname = sysname,envname = envname,envtype = envtype,instancetype = insttype,systemtype = systype,ip = ip,sid = sid,ostype = ostype,osversion = osversion,dbtype = dbtype,dbversion = dbversion,appuid = appuid,dbuid = dbuid,apppassword = finalencryprtedpwd,dbpassword=finaldbencryprtedpwd,port = port,created_at= created_at,modified_at = modified_at,status = 1,sub_by=sub_by)
				instance.save()
				swsdl = Systemwsdl(sywsdluniqueid=sywsdluniqueid.hex,customer_id= customer_id,system_id=system_id.hex,syswsdlurl=wsdl,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
				swsdl.save()
				users = i['guiuserinfo']
				instancelistsingle(ip,appuid,pwd,system_id.hex,customer_id,wsdl)
				currentalerts(wsdl,appuid,pwd,system_id.hex,customer_id)
				for j in users:
					usersuniqueid = uuid.uuid4()
					hostname = j['apphostname']
					uname = j['appusername']
					userpwd = j['apppassword']
					sysnr = j['appsysno']
					routerstring = j['approuterstring']
					euserpwd = cipher_suite.encrypt(str.encode(userpwd))
					userinfo = Applicationusers(usersuniqueid = usersuniqueid.hex,system_id = system_id,ip = hostname,username = uname,password=euserpwd,sysnr = sysnr,routerstring = routerstring,created_at = created_at,modified_at = modified_at,sub_by = sub_by)
					userinfo.save()

	return Response(request.data, status=status.HTTP_201_CREATED)								


@api_view(['POST'])
def sysaddv2(request):
	if request.method == 'POST':
			cipher_suite = Fernet(key)
			formData = request.data.get("data") 
			envname = formData['environmentselected'] 
			envtype = formData['environmentTypeSelected'] 
			insttype = formData['instanceTypeSelected'] 
			systype= formData['systemTypeSelected'] 
			solution_id = formData['solutionselected']
			systemsinfo = formData['systemsinfo']
			customer_id = formData['customer_id']
			sub_by = formData['sub_by']
			
			solname = solutionname(solution_id)
			sysname = envtype + '_' + solname + '_' + systype
			
			system_id = uuid.uuid4()
			ostype = systemsinfo['ostype']
			dbtype = systemsinfo['dbtype']
			sid = systemsinfo['sid']
			ip = systemsinfo['ip']
			pwd = systemsinfo['password']
			port = systemsinfo['port']
			osversion = systemsinfo['osversion']
			appuid = systemsinfo['appuid']
			dbversion = systemsinfo['dbversion']
			encryprtedpwd = cipher_suite.encrypt(str.encode(pwd))
			finalencryprtedpwd = encryprtedpwd.decode()
			created_at = datetime.datetime.now()
			modified_at =datetime.datetime.now()	
			sywsdluniqueid = uuid.uuid4()
			wsdl = 'http://' + ip + ':' + port + '/?wsdl' 			
			sys_obj = SystemsV2(sysuniqueid = system_id.hex,customer_id = customer_id,solution_id = solution_id,sysname = sysname,envname = envname,envtype = envtype,instancetype = insttype,systemtype = systype,ip = ip,sid = sid,ostype = ostype,osversion = osversion,dbtype = dbtype,dbversion = dbversion,appuid = appuid,apppassword = finalencryprtedpwd,port = port,created_at= created_at,modified_at = modified_at,status = 1,sub_by=sub_by)
			sys_obj.save()
			swsdl = Systemwsdl(sywsdluniqueid=sywsdluniqueid.hex,customer_id= customer_id,system_id=system_id.hex,syswsdlurl=wsdl,created_at=created_at,modified_at=modified_at,sub_by=sub_by,status=1)
			swsdl.save()
			instancelistsingle(ip,sid,pwd,system_id.hex,customer_id,wsdl)

			return Response({"message":"System added successfully"} ,status=status.HTTP_201_CREATED)

@api_view(['POST'])
def customeradd(request):
	if request.method == 'POST':
		formData = request.data.get("formData") 
		companyname = formData['companyname']		
		fname = formData['fname']
		lname = formData['lname']		
		email = formData['email']		
		companycontact = formData['companycontact']		
		pwd = formData['password']		
		address = formData['address']	
		hashAndSalt = bcrypt.hashpw(pwd.encode(), bcrypt.gensalt()) 
		fpwd = hashAndSalt.decode('utf8')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = email	
		cusuniqueid = uuid.uuid4() 
		customer = CustomerMang(cusuniqueid = cusuniqueid.hex,cuscomname = companyname,firstname=fname,lastname=lname,cusmobnum=companycontact,cusaddress=address,cusemail=email,cuspassword=fpwd,isverified = 0,status=1,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
		customer.save()
		useruniqueid = uuid.uuid4()	
		obj = Rolemang.objects.get(roleuniqueid='8fef33ff1c9d420c975e797d5c74e0c2')
		rolename = obj.rolename
		isverified = 1
		user_status = 1	
		user = Usermanagement(useruniqueid = useruniqueid.hex,customer_id = cusuniqueid.hex,fname = fname,lname=lname,email = email,password = fpwd,role=rolename,isverified=isverified,status=user_status,sub_by=email,created_at = created_at,modified_at = modified_at,mobilenum = companycontact,role_id = '8fef33ff1c9d420c975e797d5c74e0c2')	
		user.save()		

		return Response({"cusuniqueid":cusuniqueid.hex,"email":email,"role_id":'8fef33ff1c9d420c975e797d5c74e0c2'}, status=status.HTTP_201_CREATED)

@api_view(['POST'])
def customeredit(request):
	if request.method == 'POST':
		formData = request.data.get("formData")
		customer_id = formData['customer_id']
		customerobj = CustomerMang.objects.get(cusuniqueid=customer_id) 		
		customerobj.companyname = formData['companyname']		
		customerobj.contactname = formData['contactname']		
		customerobj.email = formData['email']		
		customerobj.companycontact = formData['companycontact']		
		customerobj.address = formData['address']	
		customerobj.modified_at = datetime.datetime.now()
		customerobj.save()
		return Response({"cusuniqueid":cusuniqueid.hex,"email":email,"message":"Update successful"}, status=status.HTTP_201_CREATED)	

@api_view(['POST'])
def login(request):
	if request.method == 'POST':
		formData = request.data.get("formData")
		email = formData["email"]
		pwd= formData["password"]

		hashpwd = Usermanagement.objects.filter(email = email).exclude(status =3).values('password')[0]['password']
		customer_id = Usermanagement.objects.filter(email = email).exclude(status =3).values('customer_id')[0]['customer_id']
		role_id = Usermanagement.objects.filter(email = email).exclude(status =3).values('role_id')[0]['role_id']
		# print(hashpwd)
		# print(pwd.encode('utf-8'))
		valid = bcrypt.checkpw(pwd.encode('utf-8'),hashpwd.encode('utf-8'))
		
		if valid:
			return Response({"message":"Success","email":email,"customerId":customer_id,"roleId" : role_id}, status=status.HTTP_200_OK)
		else:
			return Response({"message":"Failed","email":email}, status=status.HTTP_200_OK)		


@api_view(['POST'])
def addsolution(request):
	if request.method == 'POST':
		customer_id = request.data.get('cid')		
		name = request.data.get('solutionname')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = request.data.get('sub_by')		
		solutionuniqueid = uuid.uuid4() 
		solution = Sapsolution(soluniqueid = solutionuniqueid.hex,customer_id = customer_id,solname=name,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
		solution.save()
		return Response({"message":"Success"}, status=status.HTTP_200_OK)

@api_view(['POST'])
def addlandscape(request):
	if request.method == 'POST':
		customer_id = request.data.get('cid')
		solution_id = request.data.get('solutionid')		
		name = request.data.get('landscapename')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = request.data.get('sub_by')		
		landscapeuniqueid = uuid.uuid4() 
		landscape = Saplandscape(landuniqueid = landscapeuniqueid.hex,customer_id = customer_id,solution_id =solution_id, landname=name,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
		landscape.save()
		return Response({"message":"Success"}, status=status.HTTP_200_OK)
#############################################################################################################
def healthcheckname(id):
	name = Healthcheck.objects.filter(healthcheckuniqueid = id).values('healthcheckname')[0]['healthcheckname']
	return name


@api_view(['GET', 'POST'])
def Gethealthchecklogs(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')

		systemId = request.data.get('sid')
		if systemId == None:
			metrics = Healthchecklogs.objects.filter(customer_id = customerId).order_by('-created_at')
			serializer = HealthchecklogsSerializer(metrics, many = True)
			for i in serializer.data:
				i['sysname'] = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = i['system_id']).values('sysname')[0]['sysname']
				i['healthcheckname'] = healthcheckname(i['healthcheck_id'])
		else:
			metrics = Healthchecklogs.objects.filter(customer_id = customerId).filter(system_id = systemId).order_by('-created_at')
			systemname = SystemsV2.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('sysname')[0]['sysname']
			serializer = HealthchecklogsSerializer(metrics, many = True)
			for i in serializer.data:
				i['sysname'] = systemname
				i['healthcheckname'] = healthcheckname(i['healthcheck_id'])
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def Gethealthcheckdata(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		healthcheck_id = request.data.get('hid')
		log_id = request.data.get('lid')
		
		modelname = Healthcheck.objects.filter(healthcheckuniqueid = healthcheck_id).values('modelname')[0]['modelname']
		serializername = Healthcheck.objects.filter(healthcheckuniqueid = healthcheck_id).values('serializername')[0]['serializername']
		updatedmodelname = eval(modelname)#eval for converting str to class. Not the right practice
		metrics = updatedmodelname.objects.filter(customer_id = customerId).filter(system_id = systemId).filter(log_id = log_id)
		updatedserializername = eval(serializername)
		serializer = updatedserializername(metrics, many = True)

		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)


@api_view(['GET', 'POST'])
def Getal(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Activelogs.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = ActivelogsSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def Getbp(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Bufferpool.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = BufferpoolSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbsnap(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbsnap.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbsnapSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbi(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = DbInstances.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbInstancesSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Gettsql(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Topsql.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = TopsqlSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbb(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbbackup.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbbackupSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbls(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dblocksnap.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DblocksnapSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbms(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbmanagersnap.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbmanagersnapSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getrs(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Runstats.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = RunstatsSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Gettbsp(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Tablespc.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = TablespcSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				


def treeparser(l):

    for i in l:
        obj_list.append((i['name'],i['description'],i['Time']))

        treeparser(i['children'])   


@api_view(['GET', 'POST'])
def parse(request):
	obj_list = []
	def treeparser(l):

	    for i in l:
	        obj_list.append((i['name'],i['description'],i['Time']))

	        treeparser(i['children'])   

	if request.method == 'POST':
		obj = request.data.get('node')
		obj_list.append((obj['name'],obj['description'],obj['Time']))
		for i in obj['children']:

		    obj_list.append((i['name'],i['description'],i['Time']))
		    treeparser(i['children'])
		output = {"parsed_tree" : obj_list, "message" : "success" }    
		return Response(output, status = status.HTTP_200_OK)    
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)		

		

@api_view(['POST'])
def sysedit(request):
	if request.method == 'POST':
			formData = request.data.get("data") 
			system_id = formData['system_id'] 
			systemobj = SystemsV2.objects.get(sysuniqueid=system_id)
			systemobj.envname = formData['environmentselected'] 
			systemobj.envtype = formData['environmentTypeSelected'] 
			systemobj.insttype = formData['instanceTypeSelected'] 
			systemobj.systype= formData['systemTypeSelected'] 
			systemobj.solution_id = formData['solutionselected']
			systemsinfo = formData['systemsinfo']
			systemobj.sub_by = formData['sub_by']
			
			solname = solutionname(solution_id)
			sysname = envtype + '_' + solname + '_' + systype

			
			systemobj.ostype = systemsinfo['ostype']
			systemobj.dbtype = systemsinfo['dbtype']
			systemobj.sid = systemsinfo['sid']
			systemobj.ip = systemsinfo['ip']
			systemobj.port = systemsinfo['port']
			systemobj.osversion = systemsinfo['osversion']
			systemobj.appuid = systemsinfo['appuid']
			systemobj.dbversion = systemsinfo['dbversion']

			pwd = systemsinfo['password']
			if pwd!=None:
				encryprtedpwd = cipher_suite.encrypt(str.encode(pwd))
				finalencryprtedpwd = encryprtedpwd.decode()
				systemobj.apppassword = finalencryprtedpwd

			systemobj.modified_at = datetime.datetime.now()
			wsdlobj = Systemwsdl.objects.get(system_id=system_id)	
			systemobj.sysname = sysname + '_' + sid
			wsdlobj.wsdl = 'http://' + ip + ':' + port + '/?wsdl' 
			wsdlobj.modified_at = datetime.datetime.now()
			wsdlobj.sub_by = formData['sub_by']			
			systemobj.save()
			wsdlobj.save()
				
	return Response({"message":"update successful"}, status=status.HTTP_201_CREATED)
